#Find Station using android camera - USE THIS ONE
from SimpleCV import * 
import time
import math
import thread
from time import sleep

mpstate = None

def cameraDetection():
    global mpstate
    disp = Display()
    
    lasttime = time.time()
    filename = "Timelog" + str(lasttime) + ".txt"
    f = open(filename, 'w')
    
    currenttime = time.time()
    f.write("Got to camera detection " + str(currenttime-lasttime) +"\n")
    lasttime = currenttime
    
    #cam = Camera(0)
    #OR
    #address = 'http://10.32.37.119:8080/videofeed'
    address = 'http://192.168.2.4:8080/videofeed'
    cam = JpegStreamCamera(address)
    print address
    
    currenttime = time.time()
    f.write("Camera stream started " + str(currenttime-lasttime) +"\n")
    lasttime = currenttime
    
    #f.close()
    
    xmin = 0 #310
    xmax = 640 #420
    ymin = 0 #160
    ymax = 480 #320
    blobmin = 2000 #2000
    while disp.isNotDone():
        override = mpstate.status.override[:]

        img = cam.getImage()
        if img != None:
            red_img_dist = img.colorDistance((255,0,0))
            bin_img = red_img_dist.binarize(100)
            blobs = bin_img.findBlobs()

            if blobs != None:
                biggestblob = blobs[-1]
                biggestblob.draw(color =(255,0,0))
                #print(biggestblob.area())
                
                currenttime = time.time()
                f.write("Fround red blob of size " + str(biggestblob.area()) + " " + str(currenttime-lasttime) +"\n")
                lasttime = currenttime
                
                if biggestblob.area() > blobmin:
                    loc = biggestblob.centroid()
                    print("Found red blob located at" + str(loc))
                                    
                    currenttime = time.time()
                    f.write("Fround red blob located at " + str(loc) + " " + str(currenttime-lasttime) +"\n")
                    lasttime = currenttime
                    
                    if biggestblob.isRectangle(tolerance = 0.051):
                        print("Found a large red rectangle!")
                        #biggestblob.drawHull(color=(0,255,0), alpha=0)
                        distance = 12389*math.pow(biggestblob.length(),-0.976)
                        print("The ground is " + str(distance) + " cm away")
                        
                        currenttime = time.time()
                        f.write("Fround red rectangle, ground is " + str(distance) + " cm away " + str(currenttime-lasttime) +"\n")
                        lasttime = currenttime
                        
                    if (biggestblob.x>xmin) and (biggestblob.x<xmax):
                        if (biggestblob.y>ymin) and (biggestblob.y<ymax):
                            print("Blob is centered, attempting to LAND")
                            #StartAdd
                            override[4] = 1000
                            print("Got here to override")
                            mpstate.status.override = override
                            mpstate.override_period.force()
                            
                            currenttime = time.time()
                            f.write("Target is centered, sending LAND command " + str(currenttime-lasttime) +"\n")
                            lasttime = currenttime
                            
                            #EndAdd
            bin_img.save(disp)
    f.close()
#StartAdd
def name():
    '''return module name'''
    return "android"

def description():
    '''return module description'''
    return "Android Camera Computer Vision"

def mavlink_packet(pkt):
    pass

def init(_mpstate):
    global mpstate
    print("Start Camera init")
    '''initialise module'''
    
    mpstate = _mpstate
    thread.start_new_thread(cameraDetection, ())
    # state = module_state()
    # mpstate.androidcam_state = state
    print("End camera init")
